from itertools import product, chain
from joblib import Parallel, delayed
from celery import group, shared_task
from main.tasks import execute_query_chunks
from main.models import QuerySnapshot

SPARQL_URL = "https://query.wikidata.org/sparql"


def execute_sparql_query_template(sparql_query, placeholders=[], placeholders_values=[], concurrency=4, chunk_size=100):
    """
    executor for handling placeholders in sparql queries
    """
    #generate the parallel queries
    generated_queries = []
    placeholders_tuples = list(product(*placeholders_values))
    
    for placeholders_tuple in placeholders_tuples:
        query = sparql_query
        for i, placeholder in enumerate(placeholders):
            query = query.replace(placeholder, placeholders_tuple[i])
        generated_queries.append(query)
    
    #execute the queries and join the results
    
    #joblib approach
    #results = Parallel(n_jobs=concurrency)(delayed(execute_query_chunks)(query, chunk_size=chunk_size) for query in generated_queries)
    #return list(chain.from_iterable(results))

    #celery approach
    signatures = []
    for query in generated_queries:
        signatures.append(execute_query_chunks.s(query, chunk_size=chunk_size))
    
    res = group(*signatures)()
    results = res.get()
    return list(chain.from_iterable(results))

    



def snapshot_geo_context_monuments(snapshot):
    """
    """
    

    # get the queries related to the geo context
    queries = snapshot.geo_context.sparql_queries.all()

    # for each query, prepare a querysnapshot record for holding results

    # execute each query and store the results in the querysnapshot record
    for query in queries:
        placeholders = []
        placeholders_values = []
        if query.placeholder:
            placeholders = [query.placeholder]
            placeholders_values = [query.values.all().values_list("value", flat=True)]


        query_snap = QuerySnapshot.objects.create(query=query, snapshot=snapshot)

        results = execute_sparql_query_template(query.sparql, placeholders, placeholders_values)
        
        query.payload = results()


    # join/unique all the results and create or update monuments with correct categories.

    
    # drop monuments
    # we can only drop monuments originated by the queries we executed. 
    # if a monument is generated by two queries, we can drop it only if both queries are executed and the monument is not in the results of any of them.

    
    # update all monuments



def snapshot_geo_context_local_contests(snapshot):
    """
    """
    

def snapshot_geo_context(geo_context):
    """
    """
    #creates a snapshot of the geo context
    task_mon = snapshot_geo_context_monuments(geo_context)
    task_con = snapshot_geo_context_local_contests(geo_context)

    #wait for the tasks to finish
    #task_mon.wait()
    #task_con.wait()

    # set the snapshot as finished



